<?php
/*
Plugin Name: Google Analytics Data Handler
Plugin URI: http://www.kagua.biz/api/google-analytics-data-handler.html
Description: グーグルアナリティクスのデータを扱いやすく。とりあえずは直近ｎ日のＰＶを表示させるショートコード。とりあえずこんな感じに書いてください。例：[gadh date="7"]
Author: kagua_biz
Version: 1.0
Author URI: http://www.kagua.biz/
Description: [gadh]で表示。
 [gadh date="7"]とすれば、表示される日数は前日を含み７日間。デフォルトは７。
 ※記事以外（テンプレートの中等）で使用の際は、
 <?php echo do_shortcode ('[gadh date="7"]'); ?>
 と記述して下さい。
　必須ライブラリ　googleanalytics.class.php
　http://www.askaboutphp.com/63/google-analytics-api-class-for-php.html
*/

//初期設定ログインなど
include('googleanalytics.class.php');
 
function gadh1($atts, $content = null) {
 
//ＰＶ表示、日数はshowで設定（表示のデフォルトは７日）。
extract(shortcode_atts(array('date' => '7',), $atts));

//設定画面で空欄が１つでも有ればリターン
if(!get_option('gaid')|!get_option('gapw')|!get_option('gano')){return;}

//値を読み込み
$gaid=get_option('gaid');
$gapw=get_option('gapw');
$gano="ga:".get_option('gano');
$hyouji="";

//メインルーチン
try {
$ga = new GoogleAnalytics($gaid,$gapw);
$ga->setProfile($gano);

//期間指定、とりあえず直近ｎ日
$today = mktime(0, 0, 0, date("m"), date("d")-1,  date("Y"));
$five = mktime(0, 0, 0, date("m"), date("d")-$date,  date("Y"));
$g1 = date("Y-m-d", $today);
$g2 = date("Y-m-d", $five);
$ga->setDateRange($g2,$g1);

//レポート取得
$report = $ga->getReport(
array('dimensions'=>urlencode('ga:date'),
'metrics'=>urlencode('ga:pageviews'),
'sort'=>'ga:date')
);

//表示ルーチン
foreach( $report as $date => $dimensions ){
  foreach( $dimensions as $metrics){
    $hyouji=$hyouji.$date."　".$metrics."pv<br/>";
  }
 }
} catch (Exception $e) {
	print 'Error: ' . $e->getMessage();
}

//最後にタグで囲います。
return '<p>'.$hyouji.'</p>';
  }


//ショートコード設定
add_shortcode("gadh","gadh1");


//管理ページ
add_action('admin_menu', 'gadh2');
 
function gadh2() {
  add_options_page('GADH options', 'PV数表示', 8, __FILE__, 'gadh3');
}
 
function gadh3() {
 
?>
<div class="wrap">
<h2>PV数表示設定</h2>
<p>グーグルアナリティクスのログイン情報を設定して下さい。</p>
<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>
<table class="form-table">
<tr valign="top">
<th scope="row">ログインＩＤ（メールアドレス）</th>
<td><input type="text" name="gaid" value="<?php echo get_option('gaid'); ?>" /></td>
</tr>
<tr valign="top">
<th scope="row">ログインパスワード</th>
<td><input type="password" name="gapw" value="<?php echo get_option('gapw'); ?>" /></td>
</tr>
<tr valign="top">
<th scope="row">プロファイルＩＤ</th>
<td><input type="text" name="gano" value="<?php echo get_option('gano'); ?>" /></td>
</tr>
</table>
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="gaid,gapw,gano" />
<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>
</form>
</div>
<?php
 
}

?>